<script setup lang="ts">
import { ref } from "vue";
import Comment from "../types/comment";
import Intervention from "../types/intervention";
import User from "../types/user";

// Récupération des droits :
const token: string = getToken() ?? "";
const decodedToken = getDecodedToken(token);
const currentUserId = getCurrentUserId(decodedToken);
const currentUser = ref<User>();

const { baseURL }: { baseURL: string } = useRuntimeConfig().app;
const { id } = useRoute().params;
const authorizationHeader = useAuthorizationHeader("application/json");
const { data: intervention } = await useFetch<Intervention>(
  baseURL + "api/interventions/" + id,
  {
    headers: authorizationHeader,
  }
);

// Transformation Date en iso
const currentDate = ref<string>("");
const date = new Date();
currentDate.value = date.toISOString();

const commentaireContent = ref<string>("");

async function submitForm(): Promise<void> {
  try {
    if (commentaireContent.value) {
      const comment: Comment = {
        message: commentaireContent.value,
        createdAt: currentDate.value,
        author: `/users/${currentUserId}`,
        intervention: `/interventions/${id}`,
      };

      await $fetch(baseURL + "api/comments", {
        method: "POST",
        headers: authorizationHeader,
        body: JSON.stringify(comment),
      });
      console.log("Le com a bien été envoyé");

      if (currentUser.value === undefined) {
        const { data: user } = await useFetch<User>(
          baseURL + "api/users/" + currentUserId,
          {
            headers: authorizationHeader,
          }
        );
        currentUser.value = user.value;
        currentUser.value.id = currentUserId;
      }

      comment.author = currentUser.value;
      intervention.value.comments.push(comment);

      commentaireContent.value = "";
    }
  } catch (error) {
    console.error(error);
    alert("Une erreur est survenue lors de l'envoi du formulaire.");
  }
}
</script>
<template>
  <h2 class="fr-px-2w">Commentaires</h2>
  <section class="fr-p-2w" v-if="intervention !== null">
    <section v-if="intervention.comments.length > 0">
      <!--       <div class="fr-hr-or fr-py-2w">
        <h3 class="fr-px-2v">Aujourd'hui</h3>
      </div> -->
      <ul>
        <li class="fr-mb-2w" v-for="comment in intervention.comments">
          <div v-if="comment.author.id === currentUserId">
            <div
              class="fr-responsive-img fr-col-12 fr-grid-row fr-grid-row--bottom comment-agent"
            >
              <div v-if="comment.author.picture != null">
                <img class="fr-p-1w" :src="comment.author.picture" alt="" />
              </div>
              <div v-else>
                <div
                  class="fr-grid-row fr-grid-row--middle fr-grid-row--center fr-ml-1v agent-initials"
                >
                  {{ getInitials(comment.author) }}
                </div>
              </div>
              <div>
                <p class="fr-p-2w">{{ comment.message }}</p>
              </div>
            </div>
            <time
              class="fr-grid-row fr-grid-row--right fr-mt-1v fr-mr-13v"
              :datetime="`${useFormatDate(comment.createdAt)}`"
              >{{ useFormatDate(comment.createdAt) }}</time
            >
          </div>
          <div v-else>
            <div
              class="fr-responsive-img fr-col-12 fr-grid-row fr-grid-row--bottom comment-externe"
            >
              <div v-if="comment.author.picture != null">
                <img class="fr-p-1w" :src="comment.author.picture" alt="" />
              </div>
              <div v-else>
                <div
                  class="fr-grid-row fr-grid-row--middle fr-grid-row--center fr-mr-1v agent-initials"
                >
                  {{ getInitials(comment.author) }}
                </div>
              </div>
              <div>
                <p class="fr-p-2w">{{ comment.message }}</p>
              </div>
            </div>
            <time
              class="fr-mt-1v fr-ml-13v"
              :datetime="`${useFormatDate(comment.createdAt)}`"
              >{{ useFormatDate(comment.createdAt) }}</time
            >
          </div>
        </li>
      </ul>
    </section>
    <aside v-else>
      Aucun commentaire pour le moment
    </aside>

    <form class="fr-mt-2w comment" @submit.prevent="submitForm">
      <textarea
        class="fr-col-12 fr-p-1w fr-pr-6w"
        placeholder="Ecrire un message"
        v-model="commentaireContent"
      />
      <button
        class="fr-icon-send-plane-fill comment-button"
        type="submit"
      ></button>
    </form>
  </section>
</template>

<style scoped>
li {
  list-style: none;
}

img {
  max-width: 4.688rem;
  max-height: 4.688rem;
  border-radius: 100%;
}

div.comment-agent {
  flex-direction: row-reverse;
  flex-wrap: nowrap;
}

div.comment-agent p {
  background-color: var(--background-alt-blue-france);
  border-radius: 1rem 1rem 0rem 1rem;
}

div.comment-externe {
  flex-wrap: nowrap;
}

div.comment-externe div {
  flex-direction: column;
}

div.comment-externe p {
  box-shadow: 0 0 0 0.063rem var(--border-default-grey);
  border-radius: 1rem 1rem 1rem 0rem;
}
.agent-initials {
  width: 3rem;
  height: 3rem;
  border-radius: 100%;
  font-weight: bold;
  font-size: 16px;
  background-color: var(--blue-france-925-125);
  color: var(--blue-france-sun-113-625);
  border: 1px solid var(--background-default-grey);
}

aside {
  font-style: italic;
  font-weight: 400;
  font-size: 16px;
  line-height: 24px;
}

textarea {
  box-shadow: 0 0 0 0.063rem var(--border-default-grey);
  border-radius: 0.625rem;
  height: 6.25rem;
}

button.comment-button {
  color: var(--background-active-blue-france);
  position: absolute;
  right: 0.5rem;
  top: 0.875rem;
}

h3 {
  background-color: var(--border-default-grey);
  border-radius: 0.625rem;
  font-weight: initial;
  text-transform: none;
}

form {
  position: relative;
}

time {
  font-size: 0.875rem;
}
</style>
